import React, { Component, PropTypes } from 'react';
import {
  NativeEventEmitter,
  NativeModules,
  Platform,
} from 'react-native';
const BGLocation = NativeModules.BGLocation;

export default class BgLocationWatch {
    constructor() {
        this.BGLocationEventEmitter = new NativeEventEmitter(NativeModules.BGLocation);
    }

    bgLocationWatchStart(){
        if(Platform.OS == 'ios') {
            BGLocation.bgLocationWatchStart();
            
        }
    }

    didUpdateLocations(cbFn) {
        if(Platform.OS == 'ios') {
            this.BGLocationEventEmitter.addListener('didUpdateLocations', 
            (location)=>{
                console.log("cbFn is called!, location is: ", location);
                cbFn(location);
            });    
        }
    }

    onPermissionDenied(cbFn) {
        if(Platform.OS == 'ios') {
            this.BGLocationEventEmitter.addListener('kCLErrorDenied', 
            (error)=>{
                console.log("kCLErrorDenied is called!, error is: ", error);
                cbFn(error);
            });    
        }
    }

    bgLocationWatchStop() {
        if(Platform.OS == 'ios') {
            this.BGLocationEventEmitter.removeListener('didUpdateLocations');
            this.BGLocationEventEmitter.removeListener('kCLErrorDenied');
        }
    }
}

//let BgLocationWatch = new BackgroundLocationWatch();
//export default BgLocationWatch;